﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;

namespace howto_arithmetic_speeds
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnGo_Click(object sender, EventArgs e)
        {
            txtByte.Clear();
            txtInt.Clear();
            txtLong.Clear();
            txtDecimal.Clear();
            txtFloat.Clear();
            txtDouble.Clear();

            txtByteSecs.Clear();
            txtIntSecs.Clear();
            txtLongSecs.Clear();
            txtDecimalSecs.Clear();
            txtFloatSecs.Clear();
            txtDoubleSecs.Clear();
            Cursor = Cursors.WaitCursor;
            Refresh();

            double sec_per_test = double.Parse(txtSecPerTest.Text);
            DateTime start_time, stop_time, time_now;
            TimeSpan elapsed;
            double trials_per_sec, ns_per_trial;

            // Byte.
            start_time = DateTime.Now;
            stop_time = start_time.AddSeconds(sec_per_test);
            for (int trial = 0; ; trial++)
            {
                byte i = 12 * 31 / 13;
                byte j = (byte)(i * 7);
                i = (byte)(j / 17);

                time_now = DateTime.Now;
                if (time_now > stop_time)
                {
                    elapsed = time_now - start_time;
                    trials_per_sec = trial / elapsed.TotalSeconds;
                    txtByte.Text = trials_per_sec.ToString("N");
                    txtByte.Refresh();
                    ns_per_trial = 1.0 / trials_per_sec * 1000000000;
                    txtByteSecs.Text = ns_per_trial.ToString("0.00");
                    txtByteSecs.Refresh();
                    break;
                }
            }

            // Int.
            start_time = DateTime.Now;
            stop_time = start_time.AddSeconds(sec_per_test);
            for (int trial = 0; ; trial++)
            {
                int i = 12345 * 54231 / 13;
                int j = i * 267;
                i = j / 287;

                time_now = DateTime.Now;
                if (time_now > stop_time)
                {
                    elapsed = time_now - start_time;
                    trials_per_sec = trial / elapsed.TotalSeconds;
                    txtInt.Text = trials_per_sec.ToString("N");
                    txtInt.Refresh();

                    ns_per_trial = 1.0 / trials_per_sec * 1000000000;
                    txtIntSecs.Text = ns_per_trial.ToString("0.00");
                    txtIntSecs.Refresh();
                    break;
                }
            }

            // Long.
            start_time = DateTime.Now;
            stop_time = start_time.AddSeconds(sec_per_test);
            for (int trial = 0; ; trial++)
            {
                long i = 12345L * 54231L / 13L;
                long j = i * 267L;
                i = j / 287L;

                time_now = DateTime.Now;
                if (time_now > stop_time)
                {
                    elapsed = time_now - start_time;
                    trials_per_sec = trial / elapsed.TotalSeconds;
                    txtLong.Text = trials_per_sec.ToString("N");
                    txtLong.Refresh();

                    ns_per_trial = 1.0 / trials_per_sec * 1000000000;
                    txtLongSecs.Text = ns_per_trial.ToString("0.00");
                    txtLongSecs.Refresh();
                    break;
                }
            }

            // Decimal.
            start_time = DateTime.Now;
            stop_time = start_time.AddSeconds(sec_per_test);
            for (int trial = 0; ; trial++)
            {
                decimal i = 12345m * 54231m / 13m;
                decimal j = i * 267m;
                i = j / 287m;

                time_now = DateTime.Now;
                if (time_now > stop_time)
                {
                    elapsed = time_now - start_time;
                    trials_per_sec = trial / elapsed.TotalSeconds;
                    txtDecimal.Text = trials_per_sec.ToString("N");
                    txtDecimal.Refresh();

                    ns_per_trial = 1.0 / trials_per_sec * 1000000000;
                    txtDecimalSecs.Text = ns_per_trial.ToString("0.00");
                    txtDecimalSecs.Refresh();
                    break;
                }
            }

            // Float.
            start_time = DateTime.Now;
            stop_time = start_time.AddSeconds(sec_per_test);
            for (int trial = 0; ; trial++)
            {
                float i = 12345f * 54231f / 13f;
                float j = i * 267f;
                i = j / 287f;

                time_now = DateTime.Now;
                if (time_now > stop_time)
                {
                    elapsed = time_now - start_time;
                    trials_per_sec = trial / elapsed.TotalSeconds;
                    txtFloat.Text = trials_per_sec.ToString("N");
                    txtFloat.Refresh();

                    ns_per_trial = 1.0 / trials_per_sec * 1000000000;
                    txtFloatSecs.Text = ns_per_trial.ToString("0.00");
                    txtFloatSecs.Refresh();
                    break;
                }
            }

            // Double.
            start_time = DateTime.Now;
            stop_time = start_time.AddSeconds(sec_per_test);
            for (int trial = 0; ; trial++)
            {
                double i = 12345d * 54231d / 13d;
                double j = i * 267d;
                i = j / 287d;

                time_now = DateTime.Now;
                if (time_now > stop_time)
                {
                    elapsed = time_now - start_time;
                    trials_per_sec = trial / elapsed.TotalSeconds;
                    txtDouble.Text = trials_per_sec.ToString("N");
                    txtDouble.Refresh();

                    ns_per_trial = 1.0 / trials_per_sec * 1000000000;
                    txtDoubleSecs.Text = ns_per_trial.ToString("0.00");
                    txtDoubleSecs.Refresh();
                    break;
                }
            }

            Cursor = Cursors.Default;
        }
    }
}
